
; Beeper DAC
; Alvin Albrecht 10.2003

main()
{
#asm

   ld sp,0
.loop
   ld de,THEEND
   ld bc,30954
   call Play
   jp loop

; Uses PWM techniques to turn beeper into a DAC
;
; de = sample source address
; hl = noptable on an exact 256 byte boundary
; bc = sample count
;
; * Carrier Frequency
;   Fc = Fcpu/(105 + 4*LEVELS)
; * Levels
;   L = Fcpu/(4*Fc) - 26.25
;   Samples can use 0..L-2 inclusive
; * Effective DAC resolution (bits)
;   DACres = 3.322*log(L-2)

; DAC Resolution    LEVELS    Fc (kHz)    Signal Bandwidth (kHz)
; --------------    ------    --------    ----------------------
;     3.46            13       22.293            11.146
;     4.70            28       16.129             8.065
;     5.67            53       11.041             5.521
;     6.34            83        8.009             4.005
;     7.57           192        4.009             2.005

DEFC LEVELS = 28

;defs #(256-((ASMPC+17)%256))
defs 161
.Play
   di
   ld hl,noptable
.sampleloop
   ld a,(de)             ; ( 7)
   ld l,a                ; ( 4)
   ld  a,$10             ; ( 7)
   out ($fe),a           ; (11)
   inc de                ; ( 6)
   ld (hl),$d3           ; (10)
   inc l                 ; ( 4)
   ld (hl),$fe           ; (10)
   xor a                 ; ( 4)
.noptable
   defs LEVELS           ; (4*LEVELS+3) three on high side
   ld (hl),a             ; ( 7)
   dec l                 ; ( 4)
   ld (hl),a             ; ( 7)
   dec bc                ; ( 6)
   ld a,b                ; ( 4)
   or c                  ; ( 4)
   jp nz, sampleloop     ; (10)
   ei
   ret

.THEEND
   defb 0

#endasm
}
