
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
   FILE *in, *out;
   int levels, c;
   int min, max;

   if (argc != 4) {
      fprintf(stderr, "Usage: %s levels infile outfile\n", argv[0]);
      fprintf(stderr, "where amplitudes used are 0..levels-2\n");
      exit(1);
   }

   if ((in = fopen(argv[2], "rb")) == NULL) {
      fprintf(stderr, "couldn't open %s for reading\n", argv[2]);
      exit(2);
   }

   if ((out = fopen(argv[3], "wb")) == NULL) {
      fprintf(stderr, "couldn't create %s for writing\n", argv[3]);
      fclose(in);
      exit(3);
   }

   levels = atoi(argv[1]);
   min = 255; max = 0;
   while ((c = fgetc(in)) != EOF) {
      if (c < min)
         min = c;
      if (c > max)
         max = c;
   }

   rewind(in);
   max -= min;
   while ((c = fgetc(in)) != EOF) {
      c -= min;
      fputc((int)(((float)(c)/max)*(levels-2)+0.5), out);
   }
   fclose(in); fclose(out);

}
